ManagementBuildingGui = {}; 

function ManagementBuildingGui:EstimatedLifetime(ManagementBuilding)

    local WaterLastDays = ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.WATER)/5;
    WaterLastDays = WaterLastDays / ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.GUESTQTY);

    local AllFillLevel = 0;
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.GRAPEJUICE);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.BREAD);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.BUTTER);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.LETTUCE);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.OLIVE);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.TOMATO);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.EGG);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.CHEESE);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.MILK);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.CEREAL);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.HONEY);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.STRAWBERRY);
    AllFillLevel = AllFillLevel + ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.CHOCOLATE);

    local LastDays = AllFillLevel / ManagementBuilding.selectedProductionPoint.storage:getFillLevel(FillType.GUESTQTY);

    if WaterLastDays < LastDays then return math.floor(WaterLastDays) end;

    return math.floor(LastDays);
end;

local CyclesDesc_OrginalText = nil;
local CostsDesc_OrginalText = nil;
local Recipe_OrginalText = nil;
local Storage_OrginalText = nil;
local toggleStorageModeButtonInfo_OrginalText = nil;

local InGameMenuProductionFrameElement = nil;
local TextRenameInterrupt = false;

local function UpdateMenuButtons(self)
    if TextRenameInterrupt == true then return end;

    InGameMenuProductionFrameElement = self;
    if self ~= nil and self.selectedProductionPoint~= nil and self.selectedProductionPoint.owningPlaceable.storeItem.name ~= g_i18n:getText("shopItem_ManagementBuilding") then 
        
        if CyclesDesc_OrginalText ~= nil then
            self.productionCyclesDesc.text = CyclesDesc_OrginalText;
            self.productionCostsDesc.text = CostsDesc_OrginalText;
            self.detailsBox.elements[8].text = Recipe_OrginalText;
            self.storageListBox.elements[1].text = Storage_OrginalText;
            self.toggleStorageModeButtonInfo.inputAction = toggleStorageModeButtonInfo_OrginalText;
        end;

        self.detailRecipeOutputLayout:setVisible(true);
        self.detailRecipeInputLayout:setVisible(true);
        self.detailsBox.elements[10]:setVisible(true);

        self.detailsBox.elements[8].textBold = true;

    return; end;

    if CyclesDesc_OrginalText == nil then
        CyclesDesc_OrginalText = self.productionCyclesDesc.text;
        CostsDesc_OrginalText = self.productionCostsDesc.text;
        Recipe_OrginalText = self.detailsBox.elements[8].text;
        Storage_OrginalText = self.storageListBox.elements[1].text;
        toggleStorageModeButtonInfo_OrginalText = self.toggleStorageModeButtonInfo.inputAction;
    end;
    

    if self.selectedProductionPoint.owningPlaceable:getName() == self.selectedProductionPoint.owningPlaceable.storeItem.name then
        TextRenameInterrupt = true;
        g_gui:showTextInputDialog({
            text = g_i18n:getText("text_Rename"),
            confirmText = g_i18n:getText("text_Confirm"),
            defaultText = "Goldcrest Valley Resort",
            callback = function(text,yes)
                InGameMenuProductionFrameElement.storageList:reloadData();
                TextRenameInterrupt = false;
                if string.len(text) < 1 then return; end;
                if yes == false then return; end;
                self.selectedProductionPoint.owningPlaceable:setName(text, nil);
            end
        });
    end;

    self.toggleStorageModeButtonInfo.inputAction = nil;

    self.storageListBox.elements[1].text = g_i18n:getText("text_Management");

    self.detailsBox.elements[10]:setVisible(false);

    self.productionCyclesDesc.text = g_i18n:getText("text_LastFood");
    self.detailCyclesPerMonth.text = ManagementBuildingGui:EstimatedLifetime(self).." "..g_i18n:getText("text_Days");

    self.productionCostsDesc.text = g_i18n:getText("text_Range");
    self.detailCostsPerMonth.text = "100m";

    self.detailRecipeOutputLayout:setVisible(false);
    self.detailRecipeInputLayout:setVisible(false);
    self.detailsBox.elements[10]:setVisible(false);

    self.detailsBox.elements[8].textMaxNumLines = 1000;
    self.detailsBox.elements[8].textMaxWidth = 0.23;
    self.detailsBox.elements[8].textVerticalAlignment = TextElement.VERTICAL_ALIGNMENT.TOP;
    self.detailsBox.elements[8].textAlignment = RenderText.ALIGN_LEFT;
    self.detailsBox.elements[8].ignoreDisabled = true;
    self.detailsBox.elements[8].text = "";
    self.detailsBox.elements[8].textBold = false;

    local isProductionListActive = self.productionList == FocusManager:getFocusedElement();
    local fillType, isInput = self:getSelectedStorageFillType();
 
    if not isProductionListActive and isInput then
        if fillType == FillType.GRAPEJUICE or fillType == FillType.BREAD or fillType == FillType.BUTTER or fillType == FillType.LETTUCE or 
        fillType == FillType.OLIVE or fillType == FillType.TOMATO or fillType == FillType.EGG or fillType == FillType.CHEESE or fillType == FillType.MILK or 
        fillType == FillType.CEREAL or fillType == FillType.HONEY or fillType == FillType.STRAWBERRY or fillType == FillType.CHOCOLATE
        then self.detailsBox.elements[8].text = g_i18n:getText("text_FoodGenericDescription"); end;

        if fillType == FillType.WOOD then self.detailsBox.elements[8].text = g_i18n:getText("text_WoodDescription"); end;
        if fillType == FillType.WATER then self.detailsBox.elements[8].text = g_i18n:getText("text_WaterDescription"); end; 
    end;

    if not isProductionListActive and not isInput then
        if fillType == FillType.RATING then self.detailsBox.elements[8].text = g_i18n:getText("text_OverallRatingDescription"); end;
        if fillType == FillType.FOODQUALITY then self.detailsBox.elements[8].text = g_i18n:getText("text_FoodQualityDescription"); end;
        if fillType == FillType.ATTRACTIONS then self.detailsBox.elements[8].text = g_i18n:getText("text_AttractivenessDescription"); end;
        if fillType == FillType.HOUSING then self.detailsBox.elements[8].text = g_i18n:getText("text_HousingDescription"); end; 
        if fillType == FillType.GUESTQTY then self.detailsBox.elements[8].text = g_i18n:getText("text_GuestCapacityDescription"); end; 
    end;

    if isProductionListActive then
        self.detailsBox.elements[8].text = g_i18n:getText("text_MainDescription");
    end;

    if isProductionListActive then
		table.insert(self.menuButtonInfo, {
			profile = "buttonOk",
			inputAction = InputAction.CHAT,
			text = g_i18n:getText("text_Reportbug"),
			callback = function()
                g_gui:showInfoDialog({text="Please write about bug that you found or suggestion that would be cool to include into the mod - Email: olaf.tnt@gmail.com"});
			end
		})

		self:setMenuButtonInfoDirty()
	end
end;

function ManagementBuildingGui:UpdateInMenu()	

    if fillType == FillType.GRAPEJUICE or fillType == FillType.BREAD or fillType == FillType.BUTTER or fillType == FillType.LETTUCE or 
    fillType == FillType.OLIVE or fillType == FillType.TOMATO or fillType == FillType.EGG or fillType == FillType.CHEESE or fillType == FillType.MILK or 
    fillType == FillType.CEREAL or fillType == FillType.HONEY or fillType == FillType.STRAWBERRY or fillType == FillType.CHOCOLATE
    then self.detailsBox.elements[8].text = g_i18n:getText("text_FoodGenericDescription"); end;

    if table.getn(InGameMenuProductionFrameElement.selectedProductionPoint.activeProductions) > 0 then
        if InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.WATER) < 1 then 
            InGameMenuProductionFrameElement.detailProductionStatus.text = g_i18n:getText("text_MissingWater");
        end;
        if InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.GRAPEJUICE) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.BREAD) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.BUTTER) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.LETTUCE) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.OLIVE) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.TOMATO) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.EGG) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.CHEESE) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.MILK) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.CEREAL) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.HONEY) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.STRAWBERRY) < 1 and 
        InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.CHOCOLATE) < 1 then
            InGameMenuProductionFrameElement.detailProductionStatus.text = g_i18n:getText("text_MissingFood");
        end;
     end;

    for i = 1, #InGameMenuProductionFrameElement.storageListBox.elements[2].elements do
        local Ielement = InGameMenuProductionFrameElement.storageListBox.elements[2].elements[i];

        if Ielement.elements[2] ~= nil and Ielement.elements[2].text ~= nil then
            local Itext = Ielement.elements[2].text;
            if Itext == g_i18n:getText("filltype_OverallRating") then
                Ielement.elements[3].text = InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.RATING).." %";
                Ielement.elements[4].elements[1].overlay.color = {0.3763, 0.6038, 0.0782, 1};
                Ielement.elements[5].text = "";
            end;
            if Itext == g_i18n:getText("filltype_FoodQuality") then
                Ielement.elements[3].text = InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.FOODQUALITY).." %";
                Ielement.elements[4].elements[1].overlay.color = {0.3763, 0.6038, 0.0782, 1};
                Ielement.elements[5].text = "";
            end;
            if Itext == g_i18n:getText("filltype_Housing") then
                Ielement.elements[3].text = InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.HOUSING).."";
                Ielement.elements[4].elements[1].overlay.color = {0.3763, 0.6038, 0.0782, 1};
                Ielement.elements[5].text = "";
            end;
            if Itext == g_i18n:getText("filltype_Attractions") then
                Ielement.elements[3].text = InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.ATTRACTIONS).." %";
                Ielement.elements[4].elements[1].overlay.color = {0.3763, 0.6038, 0.0782, 1};
                Ielement.elements[5].text = "";
            end;
            if Itext == g_i18n:getText("filltype_GuestCapacity") then
                Ielement.elements[3].text = InGameMenuProductionFrameElement.selectedProductionPoint.storage:getFillLevel(FillType.GUESTQTY).."";
                Ielement.elements[4].elements[1].overlay.color = {0.3763, 0.6038, 0.0782, 1};
                Ielement.elements[5].text = "";
            end;
        end;
    end
end;

function ManagementBuildingGui:update()	
    if InGameMenuProductionFrameElement == nil or InGameMenuProductionFrameElement.selectedProductionPoint ~= nil and InGameMenuProductionFrameElement.selectedProductionPoint.owningPlaceable.storeItem.name ~= g_i18n:getText("shopItem_ManagementBuilding") then return; end; 
    if true then
        if InGameMenuProductionFrameElement.storageList == FocusManager:getFocusedElement() or InGameMenuProductionFrameElement.productionList == FocusManager:getFocusedElement() then
            ManagementBuildingGui:UpdateInMenu();
        end;
    end;
end;

function ManagementBuildingGui:GetAllManagementBuildings()
    ManagementBuildings = {}
    for i=#g_currentMission.placeableSystem.placeables, 1, -1 do
        local Cplaceable = g_currentMission.placeableSystem.placeables[i];
        if Cplaceable ~= nil and Cplaceable.storeItem.name == g_i18n:getText("shopItem_ManagementBuilding") then  ManagementBuildings[table.getn(ManagementBuildings) + 1] = Cplaceable; end;
    end
    return ManagementBuildings;
end;

function ManagementBuildingGui:DrawHudHint()

    local Px, Py, Pz = getTranslation(g_currentMission.player.rootNode);

    local ManagementBuildings = AgritourismPackMaster:GetAllManagementBuildings();
    if ManagementBuildings == nil or table.getn(ManagementBuildings) < 1 then return; end;
    
    for i = 1, table.getn(ManagementBuildings) do
        local CurrentManagementBuilding = ManagementBuildings[i];
        if ManagementBuildingGui:DistanceFrom(Px,Pz,CurrentManagementBuilding.position.x,CurrentManagementBuilding.position.z) < 25 then
            self.isEnabled = false;
            return;
        end;
    end;

    self.isEnabled = true;
end

function ManagementBuildingGui:DistanceFrom(x1,y1,x2,y2) return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2) end

InfoDisplay.draw = Utils.appendedFunction(InfoDisplay.draw, ManagementBuildingGui.DrawHudHint);
InGameMenuProductionFrame.updateMenuButtons = Utils.appendedFunction(InGameMenuProductionFrame.updateMenuButtons, UpdateMenuButtons);
addModEventListener(ManagementBuildingGui);
--self:showNotification(aiMessage)